<?php
    class core{
        public $disp = array();
        var $mss = 0;
        var $ii = 0;
        public $starttime;
        public $mtime;
        public $gentime;
        public $endtime;
        public $noHeader = "no";
        public $noFooter = "no";
        private $cacheExtension = '.php';
        var $emsg,$ereason,$emodule,$esection,$edate;

        function __construct() {
            $this->startTimer();
            $this->tpl = Toolkit::getInstance()->getTPLInstance();
            $this->text = Toolkit::getInstance()->getTextInstance();
        }

        public function genPage() {
            global $Config;
            for($ii=0; $ii < count($this->disp); $ii++) {
                $this->tpl->display($this->disp[$ii].$Config->tplEx);
            }
        }

        public function checkSiteStatus() {
            global $Config;
            if($Config->siteStatus == 'off' ) {
                $this->tpl->assign('siteTitle',$Config->siteTitle);
                $this->tpl->assign('siteUrl',$Config->siteUrl);
                $this->tpl->assign('skinDir',$Config->skinDir);
                $this->tpl->assign('reason',$Config->siteStatusReason);
                $this->tpl->display('site-off'.$Config->tplEx);
                die();
            }
        }

		public function checkCache($cacheFile) {
            global $Config;
			if(file_exists('system/cache/cache_'.md5($cacheFile . $this->cacheExtension) )){
				$fileCreationDate = stat('system/cache/cache_'.md5($cacheFile . $this->cacheExtension) );
				if($fileCreationDate['atime'] >= (time() - $Config->cacheLifeTime)) {
					Return true;
				}
			}
			else {
				Return false;
			}
		}

		public function getCache($cacheFile) {
			return file_get_contents('system/cache/cache_'.md5($cacheFile . $this->cacheExtension) );
		}

		public function writeCache($cacheFile, $data) {
			file_put_contents('system/cache/cache_'.md5($cacheFile . $this->cacheExtension), $data);
		}

		public function setNoHeader() {
			if($this->noHeader == 'no') {
				$this->noHeader = 'yes';
			}
		}

		public function checkHeader() {
			if($this->noHeader == 'yes') {
				array_shift($this->disp);
			}
		}

		public function setNoFooter() {
			if($this->noFooter == 'no') {
				$this->noFooter = 'yes';
			}
		}

		public function checkFooter() {
			if($this->noFooter == 'yes') {
				array_pop($this->disp);
			}
		}

        public function addDisp($disp) {
            $this->disp[] = $disp;
        }

        public function startTimer() {
            $this->mtime = microtime();
            $this->mtime = explode(" ",$this->mtime);
            $this->mtime = $this->mtime[1] + $this->mtime[0];
            $this->starttime = $this->mtime;
        }

        public function stopTimer() {
            $this->mtime = microtime();
            $this->mtime = explode(" ",$this->mtime);
            $this->mtime = $this->mtime[1] + $this->mtime[0];
            $this->endtime = $this->mtime;
            $this->gentime = round(($this->endtime - $this->starttime), 4);
            Return $this->gentime;
        }

        public function fatalError($emodule = "", $esection = "", $ereason = "") {
            global $tpl;
            $tpl->assign("esection",$esection);
            $tpl->assign("emodule",$emodule);
            $tpl->assign("ereason",$ereason);
            $tpl->assign("edate",$this->text->mygmt(time()));
            $tpl->display("errors/error_fatal.tpl");
            die();
        }

        public function getUserIp() {
            if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
                $ip = $this->checkGet($_SERVER['HTTP_X_FORWARDED_FOR']);
            }
            elseif(isset($_SERVER['HTTP_FORWARDED_FOR'])) {
                $ip = $this->checkGet($_SERVER['HTTP_FORWARDED_FOR']);
            }
            else {
                if(isset($_SERVER['HTTP_CLIENT_IP'])) {
                    $ip = $this->text->checkGet($_SERVER['HTTP_CLIENT_IP']);
                }
                else {
                    $ip = $this->text->checkGet($_SERVER['REMOTE_ADDR']);
                }
            }
            Return $ip;
        }

        public function rebuild_array($arr) {
			$arr = array_reverse($arr);
            Return $arr;
        }

        public function errorPage($errnum) {
            global $Config;
            if($errnum == "404") {
                require_once($Config->dRoot . '/system/errors/404.php');
            }
            elseif($errnum == "403") {
                require_once($Config->dRoot . '/system/errors/403.php');
            }
            elseif($errnum == "401") {
                require_once($Config->dRoot . '/system/errors/401.php');
            }
            elseif($errnum == "500") {
                require_once($Config->dRoot . '/system/errors/500.php');
            }
            die();
        }


		public function gzipOut() {
			$gzip_contents = ob_get_contents();
			ob_end_clean();

			echo $gzip_contents;
		}
    }
?>