<?php
    class Toolkit {
        private static $instance = false;
        private static $toolkits = array();

        public static function getInstance() {
            if(false == self::$instance) {
                self::$instance = new Toolkit();
            }
            return(self::$instance);
        }

		public function getTextInstance() {
            if(!isset(self::$toolkits['text'])) {
                Files::load('system/classes/class.text.php');
                self::$toolkits['text'] = new text();
            }
            return(self::$toolkits['text']);
        }

		public function getPageSeparationInstance() {
            if(!isset(self::$toolkits['pageSeparation'])) {
                Files::load('system/classes/class.pageSeparation.php');
                self::$toolkits['pageSeparation'] = new pageSeparation();
            }
            return(self::$toolkits['pageSeparation']);
		}

		public function getMailerInstance() {
            if(!isset(self::$toolkits['mailer'])) {
                Files::load('system/classes/class.mailer.php');
				self::$toolkits['mailer'] = new mailer();
            }
			return(self::$toolkits['mailer']);
        }

        public function getTPLInstance() {
            global $Config;
            if(!isset(self::$toolkits['tpl'])) {
                include('system/classes/smarty/Smarty.class.php');
                self::$toolkits['tpl'] = new Smarty();
                self::$toolkits['tpl'] -> caching = false;
                self::$toolkits['tpl'] -> left_delimiter = '{';
                self::$toolkits['tpl'] -> right_delimiter = '}';
                self::$toolkits['tpl'] -> template_dir = $Config->dRoot.'/templates/'.$Config->skinDir.'/';
                self::$toolkits['tpl'] -> compile_dir = $Config->dRoot.'/templates/'.$Config->skinDir.'/cache/';
                self::$toolkits['tpl'] -> config_dir = $Config->dRoot.'/system/configs/';
                self::$toolkits['tpl'] -> cache_dir = $Config->dRoot.'/system/cache/';
            }
            return(self::$toolkits['tpl']);
        }
    } 

?>